'\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\

									'Mathematical Function

'///////////////////////////////////////////////////////////////////////////////////////////////////


'///////////////////////////////////////////////////////////////////////////////////////////////////
							' Setting the Analogboard DAC Output Voltage
'///////////////////////////////////////////////////////////////////////////////////////////////////
Function SetVoltage(fVoltage As Float) As Byte
Local iSetv As Byte
Dim Vsetm As Word		' The Master DAC Setting Return
Dim Vsets As Word		' The Slave  DAC Setting Return
Dim mbMSB As Byte
Dim mbLSB As Byte	
Dim sbMSB As Byte
Dim sbLSB As Byte
' the VOut = Gain * (Vmaster * Rs + Vslave * Rm) / (Rm+Rs), Fullscale of the Vm = 5V and Vs = -5V, Gain = 2.5
fVtrn = fVoltage / 1000000
fVtrn = fVtrn / fDACGain
fVset = fVtrn
iSetv = fVset
'Format(2,0) : Charat = Str(iSetv) : DrawChr(1,6)
If iSetv > 8 Then
	fDefslave = fDACHCenter
Else
	fDefslave = fDACLCenter
End If
'Get the MasteDAC Voltage Setting Value, Vm=[Vo*(Rm+Rs)+2.5*Rm]/Rs , at Default, the Slave DAC Output = -2.5V
fVtrn = (fVtrn * (fMResistance + fSResistance) - fDefslave * fMResistance) / fSResistance' : Format(2,5) : Charat = Str(fVtrn) : DrawChr(38,4)
If bRun = 1 Then
	Format(2,6) : Charat = Str(fVtrn) : DrawChr(132,1)
End If
fVtrn = fVtrn * 65535 / fDACReference							'The Master DAC(MAX541) is 16bit DAC, Fullscale = 2^16 = 65536
Vsetm = fVtrn' : Charat = Hex(Vsetm) : DrawChr(1,6)
'mbMSB = Vsetm / 256  												'Split the Setting Word to two Byte, Get the MSB Byte
mbMSB = Msb(Vsetm)
mbLSB = Vsetm - mbMSB * 256										'Split the Setting Word to two Byte, Get the LSB Byte
' Get the SlaveDAC Voltage Setting Value,Vs=[Vo*(Rm+Rs)-Vm*Rs]/Rm
fVtrn = Vsetm * fDACReference / 65535
fVtrn = (fVset * (fMResistance + fSResistance) - fVtrn * fSResistance) / fMResistance' : Format(2,4) : Charat = Str(fVtrn) : DrawChr(1,7)
If bRun = 1 Then
	Format(2,6) : Charat = Str(fVtrn) : DrawChr(132,2)
End If
fVtrn = fVtrn * 32768 / fDACReference							'The Slave DAC(MAX515) is 12bit DAC, Fullscale = 2^12 = 4096
Vsets = fVtrn
Vsets = Vsets + 32768
sbMSB = Msb(Vsets)												'Split the Setting Word to two Byte, Get the MSB Byte
sbLSB = Vsets - sbMSB * 256										'Split the Setting Word to two Byte, Get the LSB Byte
WriteDAC(mbMSB, mbLSB, sbMSB, sbLSB)						'Update the Control Shift-Register, DAC tobe Update
If bRun = 1 Then
	Charat = Hex(mbMSB) : DrawChr(144,0)
	Charat = Hex(mbLSB) : DrawChr(156,0)
	Charat = Hex(sbMSB) : DrawChr(168,0)
	Charat = Hex(sbLSB) : DrawChr(180,0)
End If
Return 0
End Function




'\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\

										'Shiftreg IO

'///////////////////////////////////////////////////////////////////////////////////////////////////


'///////////////////////////////////////////////////////////////////////////////////////////////////
							' Setting the Analog Switch(ADC Input Channel)
'///////////////////////////////////////////////////////////////////////////////////////////////////
Function SetChannel(Channel As Byte) As Byte				
Local Channelset As Byte
Channelset = bSregister And &b11110000
'WriteSReg(Channelset)		' Open all Analog Switch when Close Next Switch
'WriteSBUS(&b11111111) : WriteSBUS(&b11111111) : WriteSBUS(Channelset)
'IO_REG_STB = 1 : WaitUs 10 : IO_REG_STB = 0
'WaitUs 10
bSregister = Channelset + Channel
'WriteSReg(bSregister)
WriteSBUS(&b11111111) : WriteSBUS(&b11111111) : WriteSBUS(bSregister)
IO_REG_STB = 1 : WaitUs 10 : IO_REG_STB = 0
WaitMs 1

Return bSregister
End Function


Function WriteDAC(bmDath As Byte, bmDatL As Byte, bsDath As Byte, bsDatL As Byte) As Byte
'Status REG Q1 = Slave HBE
'			Q2 = Slave LBE
'			Q3 = Master HBE
'			Q4 = Master LBE
'			Q5 = Slave CS
'			Q6 = Slave LDAC
'			Q7 = Master CS
'			Q8 = Master LDAC

' Write the Master DAC 
' Set the Msster DAC 8bit MSB Bank to Write
WriteSBUS(&b10111011) : WriteSBUS(bmDath) : WriteSBUS(bSregister)
IO_REG_STB = 1 : WaitUs 10 : IO_REG_STB = 0
' Storbe the 8bit MSB Bank
WriteSBUS(&b10111111) : WriteSBUS(bmDath) : WriteSBUS(bSregister)
IO_REG_STB = 1 : WaitUs 10 : IO_REG_STB = 0
' Set the Msster DAC 8bit LSB Bank to Write
WriteSBUS(&b10110111) : WriteSBUS(bmDatL) : WriteSBUS(bSregister)
IO_REG_STB = 1 : WaitUs 10 : IO_REG_STB = 0
WriteSBUS(&b10111111) : WriteSBUS(bmDatL) : WriteSBUS(bSregister)
IO_REG_STB = 1 : WaitUs 10 : IO_REG_STB = 0
' Storbe the 8bit LSB Bank
WriteSBUS(&b00111111) : WriteSBUS(0) : WriteSBUS(bSregister)
IO_REG_STB = 1 : WaitUs 10 : IO_REG_STB = 0
' Latches Transparent to Master DAC
WriteSBUS(&b11111111) : WriteSBUS(0) : WriteSBUS(bSregister)
IO_REG_STB = 1 : WaitUs 10 : IO_REG_STB = 0
' Write the Slave DAC 
' Set the Slave DAC 8bit MSB Bank to Write
WriteSBUS(&b11101110) : WriteSBUS(bsDath) : WriteSBUS(bSregister)
IO_REG_STB = 1 : WaitUs 10 : IO_REG_STB = 0
' Storbe the 8bit MSB Bank
WriteSBUS(&b11101111) : WriteSBUS(bsDath) : WriteSBUS(bSregister)
IO_REG_STB = 1 : WaitUs 10 : IO_REG_STB = 0
' Set the Slave DAC 8bit LSB Bank to Write
WriteSBUS(&b11101101) : WriteSBUS(bsDatL) : WriteSBUS(bSregister)
IO_REG_STB = 1 : WaitUs 10 : IO_REG_STB = 0
WriteSBUS(&b11101111) : WriteSBUS(bsDatL) : WriteSBUS(bSregister)
IO_REG_STB = 1 : WaitUs 10 : IO_REG_STB = 0
' Storbe the 8bit LSB Bank
WriteSBUS(&b11001111) : WriteSBUS(0) : WriteSBUS(bSregister)
IO_REG_STB = 1 : WaitUs 10 : IO_REG_STB = 0
' Latches Transparent to Slave DAC
WriteSBUS(&b11111111) : WriteSBUS(0) : WriteSBUS(bSregister)
IO_REG_STB = 1 : WaitUs 10 : IO_REG_STB = 0

Return 0
End Function