'///////////////////////////////////////////////////////////////////////////////////////////////////

										'12864 OLED Screen Drive

'///////////////////////////////////////////////////////////////////////////////////////////////////
'///////////////////////////////////////////////////////////////////////////////////////////////////

										'Screen Drive

'///////////////////////////////////////////////////////////////////////////////////////////////////

Function InitOLED() As Byte
'----------------------- LCD Power Up -----------------------
WriteInstruction(&hae) 					'Display OFF
		
WriteInstruction(&hd5)					'Crystal Oscillator Frequency Set
WriteInstruction(&h80) 

WriteInstruction(&ha8) 					'Duty Set
WriteInstruction(&h3f) 					'Duty = 1/64

WriteInstruction(&hd3) 					'Display Offset Set
WriteInstruction(&h00) 					'Set to Zero

WriteInstruction(&h40)					'Set Display Address Start
 
WriteInstruction(&h8d)					'OLCD BIAS Power Up
WriteInstruction(&h14) 

WriteInstruction(&h20) 					'Set to Page Address Mode
WriteInstruction(&h02) 

WriteInstruction(&hc8) 					'LCD Vertica Scan Set(From TOP to Bottom)
WriteInstruction(&ha1) 					'LCD Horizontal Scan Set(From Left to Rgiht)

WriteInstruction(&hda)					'sequential configuration
WriteInstruction(&h12) 

WriteInstruction(&h81)					'LCD Contrast(Light <-- OLED) Micro-Adjust Command
WriteInstruction(&hff)					'LCD Contrast(Light <-- OLED) Micro-Adjust Value, &h00~&hff
 
WriteInstruction(&hd9) 					'Set Precharge Period
WriteInstruction(&hf1) 

WriteInstruction(&hdb) 					'Set VCOMH Deselect Level

WriteInstruction(&h40)

WriteInstruction(&haf)					'Display ON
Return 0
End Function

Function ResetOLED() As Byte								' Ļϵ壬һӲ·
IO_SCR_RST = 0
WaitMs 200
IO_SCR_RST = 1
End Function

'///////////////////////////////////////////////////////////////////////////////////////////////////
							' Wrtie the Serial BUS LCD Shift-Register
'///////////////////////////////////////////////////////////////////////////////////////////////////
Function WriteInstruction(bDat As Byte) As Byte
'Local i As Byte
'Local bWritedat As Byte
'Local bWritebit As Byte
'bWritedat = bDat
IO_SCR_DoI = 0
IO_SCR_CST = 0
'WaitUs 1

ShiftOut bDat


'For i = 1 To 8
'    bWritebit = bWritedat And &b10000000
'    If bWritebit = 128 Then
'       IO_SCR_DAT = 1
'    Else
'       IO_SCR_DAT = 0
'    End If 
'    WaitUs 1
'    IO_SCR_CLK = 1 : WaitUs 1 : IO_SCR_CLK = 0
'    bWritedat = Shift(Left, 1, bWritedat)  
'Next i
'WaitUs 1

IO_SCR_DoI = 0
IO_SCR_CST = 1

Return 0
End Function


Function WriteDatums(bDat As Byte) As Byte
'Local i As Byte
'Local bWritedat As Byte
'Local bWritebit As Byte
'bWritedat = bDat
IO_SCR_DoI = 1
IO_SCR_CST = 0
'WaitUs 1

ShiftOut bDat


'For i = 1 To 8
'    bWritebit = bWritedat And &b10000000
'    If bWritebit = 128 Then
'       IO_SCR_DAT = 1
'    Else
'       IO_SCR_DAT = 0
'    End If 
'    WaitUs 1
'    IO_SCR_CLK = 1 : WaitUs 1 : IO_SCR_CLK = 0
'    bWritedat = Shift(Left, 1, bWritedat)  
'Next i
'WaitUs 1

IO_SCR_DoI = 0
IO_SCR_CST = 1

Return 0
End Function

'///////////////////////////////////////////////////////////////////////////////////////////////////
							' LCD Diaply Function
'///////////////////////////////////////////////////////////////////////////////////////////////////
'Function DisplayAddresset(Disx As Byte, DisY As Byte)

'End Function

Function DisplayCls(bDat As Byte) As Byte
Local iM As Byte
Local iL As Byte
Local iX As Byte
Local iY As Byte

For iY = 0 To 7
	WriteInstruction(&hb0 + iY)
	For iX = 2 To 129
		iL = iX : iL = iL And &h0f
		iM = iX : iM = Swap(iM) : iM = iM And &h0f : iM = iM + &h10
		WriteInstruction(iM) : WriteInstruction(iL)
		WriteDatums(bDat)
	Next iX
Next iY

Return 0
End Function

Function DrawPage(dX As Byte, dY As Byte, dDatums As Byte) As Byte
Local iLine As Byte										' Դһдҳĺ
Local iM As Byte
Local iL As Byte

WriteInstruction(&hb0 + dY)
iL = dX + 1 : iL = iL And &h0f
iM = dX + 1 : iM = Swap(iM) : iM = iM And &h0f : iM = iM + &h10
WriteInstruction(iM) : WriteInstruction(iL)
WriteDatums(dDatums)
Return 0
End Function

Function DrawChr(dX As Byte, dY As Byte) As Byte		' ʾһַдڵı׼ ASCII ַ
Local is As Byte
Local iLs As Byte
Local iFn As Byte
Local iChn As Byte
Local bChr As Byte
Local xAdd As Byte

xAdd = 0
iLs = Len(Charat)

For is = 1 To iLs
    bChr = Asc(Mid(Charat,is,1)) - 32					' ÿһַ ASCII ҵӦݣһַ 5x8  5  Byte 
    For iFn = 0 To 4
        iChn = Ft1(bChr * 5 + iFn)
        DrawPage(dX+xAdd,dY,iChn)						' ÿһַӦ 5  Byte дԴ
        xAdd = xAdd + 1
    Next iFn
    xAdd = xAdd + 1
Next is
Return 0
End Function

Function DrawChrLarge(x As Byte, Page As Byte) As Byte		' ʾһַдڵı׼ ASCII ַ
Local is As Byte
Local iLs As Byte
Local iFn As Byte
Local iChn As Byte
Local bChr As Byte
Local xAdd As Byte

xAdd = 0
iLs = Len(Charat)

For is = 1 To iLs
    bChr = Asc(Mid(Charat,is,1)) - 32					' ÿһַ ASCII ҵӦݣһַ 6x16  ?  Byte 
    For iFn = 0 To 11
        iChn = Ft2(bChr * 12 + iFn)
        If iFn < 6 Then
           DrawPage(x+xAdd,Page,iChn)						' ÿһַӦ 5  Byte дԴ
        Else
           DrawPage(x+xAdd-6,Page + 1,iChn)        
        End If
        xAdd = xAdd + 1
    Next iFn
    xAdd = xAdd - 6
    xAdd = xAdd + 1
Next is
Return 0
End Function