'///////////////////////////////////////////////////////////////////////////////////////////////////

										'12864 OLED Screen Drive

'///////////////////////////////////////////////////////////////////////////////////////////////////
'///////////////////////////////////////////////////////////////////////////////////////////////////

										'Screen Drive

'///////////////////////////////////////////////////////////////////////////////////////////////////

Function InitDisplay() As Byte

IO_SCR_RST = 0
WaitMs 200
IO_SCR_RST = 1

'----------------------- LCD Power Up -----------------------
WriteInstruction(&hfd)			'Unlock Driver IC (0x12/0x16)
WriteDatums(&h12)

WriteInstruction(&hae)			'Display Off (0xAE/0xAF)

WriteInstruction(&hd5)
WriteInstruction(&h80)			'Set Clock as 116 Frames/Sec

WriteInstruction(&ha8)			'Set Multiplex Ratio
WriteInstruction(&h3f)			'1/64 Duty (0x0F~0x3F)

WriteInstruction(&hd3)			'Set Display Offset
WriteInstruction(&h00)			'Shift Mapping RAM Counter (0x00~0x3F)


WriteInstruction(&h40)			'Set Display Start Line
WriteInstruction(&h00)			'Set Mapping RAM Display Start Line (0x00~0x3F)

WriteInstruction(&h20)			'Set Memory Addressing Mode
WriteInstruction(&h02)			'Set Page Addressing Mode (0x00/0x01/0x02)



WriteInstruction(&hc8)			'Set COM/Row Scan Direction (0xC0/0xC8)
WriteInstruction(&ha1)			'Set SEG/Column Mapping (0xA0/0xA1)


WriteInstruction(&hda)			'Set COM Pins Hardware Configuration
WriteInstruction(&h12)			'Set Alternative Configuration (0x02/0x12)

WriteInstruction(&h81)			'Set Contrast Control for Bank 0
WriteInstruction(&h00)			'Set SEG Output Current

WriteInstruction(&hd9)			'Set Pre-Charge Period
WriteInstruction(&h82)			'Set Pre-Charge as 8 Clocks & Discharge as 2 Clocks

WriteInstruction(&hdb)			'Set VCOMH Deselect Level
WriteInstruction(&h34)			'Set VCOM Deselect Level


WriteInstruction(&ha4)			'Disable Entire Display On (0xA4/0xA5)


WriteInstruction(&ha6)			'Disable Inverse Display On (0xA6/0xA7)


WriteInstruction(&haf)			'Display On (0xAE/0xAF)
Return 0
End Function



'///////////////////////////////////////////////////////////////////////////////////////////////////
							' Wrtie the Serial BUS LCD Shift-Register
'///////////////////////////////////////////////////////////////////////////////////////////////////
Function WriteInstruction(bDat As Byte) As Byte
'Local i As Byte
'Local bWritedat As Byte
'Local bWritebit As Byte
'bWritedat = bDat
IO_SCR_DoI = 0
IO_SCR_CST = 0
'WaitUs 1

ShiftOut bDat


'For i = 1 To 8
'    bWritebit = bWritedat And &b10000000
'    If bWritebit = 128 Then
'       IO_SCR_DAT = 1
'    Else
'       IO_SCR_DAT = 0
'    End If 
'    WaitUs 1
'    IO_SCR_CLK = 1 : WaitUs 1 : IO_SCR_CLK = 0
'    bWritedat = Shift(Left, 1, bWritedat)  
'Next i
'WaitUs 1

IO_SCR_DoI = 0
IO_SCR_CST = 1

Return 0
End Function


Function WriteDatums(bDat As Byte) As Byte
'Local i As Byte
'Local bWritedat As Byte
'Local bWritebit As Byte
'bWritedat = bDat
IO_SCR_DoI = 1
IO_SCR_CST = 0
'WaitUs 1

ShiftOut bDat


'For i = 1 To 8
'    bWritebit = bWritedat And &b10000000
'    If bWritebit = 128 Then
'       IO_SCR_DAT = 1
'    Else
'       IO_SCR_DAT = 0
'    End If 
'    WaitUs 1
'    IO_SCR_CLK = 1 : WaitUs 1 : IO_SCR_CLK = 0
'    bWritedat = Shift(Left, 1, bWritedat)  
'Next i
'WaitUs 1

IO_SCR_DoI = 0
IO_SCR_CST = 1

Return 0
End Function

'///////////////////////////////////////////////////////////////////////////////////////////////////
							' LCD Diaply Function
'///////////////////////////////////////////////////////////////////////////////////////////////////
'Function DisplayAddresset(Disx As Byte, DisY As Byte)

'End Function

Function DisplayCls(bDat As Byte) As Byte
Local iM As Byte
Local iL As Byte
Local iX As Byte
Local iY As Byte

For iY = 0 To 7
	WriteInstruction(&hb0 + iY)
	'For iX = 2 To 129
	For iX = 0 To 127
		iL = iX : iL = iL And &h0f
		iM = iX : iM = Swap(iM) : iM = iM And &h0f : iM = iM + &h10
		WriteInstruction(iM) : WriteInstruction(iL)
		WriteDatums(bDat)
	Next iX
Next iY

Return 0
End Function

Function DrawPage(dX As Byte, dY As Byte, dDatums As Byte) As Byte
Local iLine As Byte										' Դһдҳĺ
Local iM As Byte
Local iL As Byte
'dx=dx-3
If dX < 129 Then
	WriteInstruction(&hb0 + dY)
	iL = dX - 1 : iL = iL And &h0f
	iM = dX - 1 : iM = Swap(iM) : iM = iM And &h0f : iM = iM + &h10
	WriteInstruction(iM) : WriteInstruction(iL)
	WriteDatums(dDatums)
	Return 0
Else
	Return 1
End If
End Function

Function DrawChr(dX As Byte, dY As Byte) As Byte		' ʾһַдڵı׼ ASCII ַ
Local is As Byte
Local iLs As Byte
Local iFn As Byte
Local iChn As Byte
Local bChr As Byte
Local xAdd As Byte

xAdd = 0
iLs = Len(Charat)

For is = 1 To iLs
    bChr = Asc(Mid(Charat,is,1)) - 32					' ÿһַ ASCII ҵӦݣһַ 5x8  5  Byte 
    For iFn = 0 To 4
        iChn = Ft1(bChr * 5 + iFn)
        DrawPage(dX+xAdd,dY,iChn)						' ÿһַӦ 5  Byte дԴ
        xAdd = xAdd + 1
    Next iFn
    xAdd = xAdd + 1
Next is
Return 0
End Function

Function DrawChrLarge(x As Byte, Page As Byte) As Byte		' ʾһַдڵı׼ ASCII ַ
Local is As Byte
Local iLs As Byte
Local iFn As Byte
Local iChn As Byte
Local bChr As Byte
Local xAdd As Byte

xAdd = 0
iLs = Len(Charat)

For is = 1 To iLs
    bChr = Asc(Mid(Charat,is,1)) - 32					' ÿһַ ASCII ҵӦݣһַ 6x16  ?  Byte 
    For iFn = 0 To 11
        iChn = Ft2(bChr * 12 + iFn)
        If iFn < 6 Then
           DrawPage(x+xAdd,Page,iChn)						' ÿһַӦ 5  Byte дԴ
        Else
           DrawPage(x+xAdd-6,Page + 1,iChn)        
        End If
        xAdd = xAdd + 1
    Next iFn
    xAdd = xAdd - 6
    xAdd = xAdd + 1
Next is
Return 0
End Function