'///////////////////////////////////////////////////////////////////////////////////////////////////

										'Voltage Generator
										'By Lilith Washu

'///////////////////////////////////////////////////////////////////////////////////////////////////
$Device= m32			' ʹõĵƬ
$Stack = 32				
$Clock = 11.0592			    ' ʹõĵƬƵ
$ShiftIn Data = PORTB.3, Clock = PORTB.4, Msb 
'$ShiftOut Data = PORTB.1, Clock = PORTB.2, Msb
$Baud = 19200,n,8,1
$1Wire = PORTD.6
$LeadChar="0", Format(2,6)

'************** Config the IO **************
' the Display Screen IO Connect
$Def IO_SCR_RST = PORTC.7
$Def IO_SCR_CSA = PORTC.6
$Def IO_SCR_CSB = PORTC.5
$Def IO_SCR_DoI = PORTC.4
$Def IO_SCR_RoW = PORTC.3
$Def IO_SCR_STB = PORTC.2
$Def IO_SCR_DAT = PORTA
' the Analog Board IO Connect
$Def IO_REG_STB = PORTB.0
$Def IO_REG_DAT = PORTB.1
$Def IO_REG_CLK = PORTB.2
$Def IO_ADC_CLK = PORTB.4
$Def IO_ADC_DAT = PINB.3
$Def IO_KEY_STB = PORTB.5
$Def IO_KEY_DAT = PINB.6
$Def IO_KEY_CLK = PORTB.7
'///////////////////////////////////////////////////////////////////////////////////////////////////
							' Constant 
'///////////////////////////////////////////////////////////////////////////////////////////////////
Const cfMasterReference = 7.0E+00		'LM399 Voltage Value	
Const cfDACReference = 1.000E+01			'DAC Voltage Reference Value
Const fDACLCenter = -5.00000E+00				'Slave DAC Default Output Voltage Value
Const fDACHCenter = 9.00000E+00
Const cfDACGain = 1.250000E+00				'DAC Output buff Gain
Const cfMResistance = 2.49E+02				'DAC Voltgae Compound Resistance, the Master
Const cfSResistance = 1E+06					'DAC Voltgae Compound Resistance, the Slave
'Const cfDacal = 1.0e+00						'DAC Fullscale Error Adjuest Vale
'Const Cubic = -5.668e-01
Const cQuadratic = 6.1282e+00				'No-line Error Adjuest Quadratic Coefficient	ϵ
Const cLinear = -3.5264+00					'No-line Error Adjuest Linear Coefficient		һϵ
Const cConstant = -8.7063e+00				'No-line Error Adjuest Offset Coefficient		
Const Synthesis = &b00000001				' Analog Switch = Synthesis Voltage Output		| DG412 Pin 
Const Reference = &b00000010   				' Analog Switch = Internal Reference(LM399)		| DG412 Pin 
Const ExternaIN = &b00000100				' Analog Switch = Externa Voltage Input			| DG412 Pin 
Const GndOffset = &b00001000				' Analog Switch = Auto Zero						| DG412 Pin  
Const ADCWalkUp = &b00000000
Const ADCPWDown = &b00010000
'
'7.037415E+00	1.0053745e+00 vg2400_no1	20150725
'7.037723E+00	9.657057e-01  vg2400_no2	20150725
'7.037611E+00	1.005126e+00  vg2400_no3	20150725
'///////////////////////////////////////////////////////////////////////////////////////////////////
							' String Variables
'///////////////////////////////////////////////////////////////////////////////////////////////////
Dim Ft1 As Flash Byte	' 
Dim Ft2 As Flash Byte	' 
Dim Charat As String *33' Ҫʾַ
Dim tTxt As String *15
Dim tm As String *7
Dim tCmd As String *4
Dim iCursors(8) As Byte
'///////////////////////////////////////////////////////////////////////////////////////////////////
							' Gen Variables
'///////////////////////////////////////////////////////////////////////////////////////////////////
Dim i As Byte	
Dim j As Byte
Dim iEEPROM As Byte
Dim bRst As Byte

Dim bINLCorrect As Byte

Dim bUartINT As Byte

Dim bPowerUp As Byte
Dim bUartset As Byte
Dim bUartlk As Byte

Dim bAdjuest As Byte
Dim bDigitaLoop As Byte 
Dim bRun As Byte
Dim bTrigcompleted As Byte
Dim bRefsource As Byte

Dim iErrlimit As Byte

Dim bSregister As Byte
Dim iSmlen As Byte		
Dim iSmsetp As Byte
Dim iBusystp As Byte
Dim iTrd As Byte
Dim iDraw As Word
Dim CurrentChannel As Byte
Dim bNextchannel As Byte
Dim itm As Byte
Dim iDa As Byte
Dim iDb As Byte
Dim iDc As Byte
Dim iDd As Byte
Dim iTa As Byte
Dim iTb As Byte
Dim iTc As Byte
Dim iTd As Byte
Dim bADCResult(3) As Byte
Dim bREGa(220) As Byte
Dim bREGb(220) As Byte
Dim bREGc(220) As Byte
Dim bREGd(220) As Byte
Dim dTempdatum(1) As Byte
Dim dTempresult As Word
Dim iError As Integer
Dim wError As Word

Dim bEEPROMh(10) As Word
Dim bEEPROMl(10) As Word
Dim tlkWordh As Word
Dim tlkWordl As Word

Dim IsTempresultSense As Byte
Dim iErrcode As Byte
Dim iKeypress As Byte
Dim iKeycode As Word

Dim iLock As Byte
Dim iLockPrv As Byte
Dim iUnlockCount As Word
'///////////////////////////////////////////////////////////////////////////////////////////////////
							' Float Variables
'///////////////////////////////////////////////////////////////////////////////////////////////////
Dim fTrn As Float
Dim fOut As Float
Dim fGndOffset As Float
Dim fReference As Float
Dim fSynthesis As Float
Dim fCalsacles As Float
Dim fCalfSynth As Float
Dim fSetting As Float
Dim fVoltage As Float
Dim fError As Float
Dim fVset As Float
Dim fVtrn As Float
Dim fTemperature As Float
Dim fDefslave As Float			'need by AD569

Dim Vseth As Word
Dim Vsetl As Word

Dim fMasterReference As Float		'LM399 Voltage Value	
Dim fDACReference As Float		'DAC Voltage Reference Value
Dim fDACGain As Float				'DAC Output buff Gain
Dim fMResistance As Float				'DAC Voltgae Compound Resistance, the Master
Dim fSResistance As Float
Dim fQuadratic As Float				'No-line Error Adjuest Quadratic Coefficient	ϵ
Dim fLinear As Float					'No-line Error Adjuest Linear Coefficient		һϵ
Dim fConstant As Float				'No-line Error Adjuest Offset Coefficient		
'Dim fDacal As Float					'DAC Fullscale Error Adjuest Vale	

'///////////////////////////////////////////////////////////////////////////////////////////////////
										' Screen Function
'///////////////////////////////////////////////////////////////////////////////////////////////////
Declare Function WriteKS(Code As Byte, Channel As Byte) As Byte				' ʾдݵĺ
Declare Function SetKS(Code As Byte, Channel As Byte) As Byte				' ʾдָĺ
Declare Function InitKS() As Byte											' ʼʾ
Declare Function ResetKS() As Byte											' ʾϵ纯Ӳ·
Declare Function ClsKS(GRAM As Byte) As Byte								' 
Declare Function DrawPix(x As Byte, y As Byte) As Byte						' ʾϻһ
Declare Function DrawPage(x As Byte, Page As Byte, Code As Byte) As Byte	' ʾϻһҳ
Declare Function DrawChr(x As Byte, Page As Byte) As Byte					' ʾһб׼ ASCII ַ
Declare Function DrawChrLarge(x As Byte, Page As Byte) As Byte					' ʾһб׼ ASCII ַ
Declare Function DrawCursors(x As Byte, Page As Byte, Length As Byte) As Byte
'///////////////////////////////////////////////////////////////////////////////////////////////////
										' IO Function
'///////////////////////////////////////////////////////////////////////////////////////////////////
Declare Function WriteSReg(bDat As Byte) As Byte
Declare Function WriteSBUS(bDat As Byte) As Byte
Declare Function WriteDAC(bmDath As Byte, bmDatL As Byte, bsDath As Byte, bsDatL As Byte) As Byte
Declare Function SetChannel(Channel As Byte) As Byte
Declare Function ReadADC() As Byte
Declare Function ReadKEY() As Byte
Declare Function MyWait() As Byte
'///////////////////////////////////////////////////////////////////////////////////////////////////
									' Mathematical Function
'///////////////////////////////////////////////////////////////////////////////////////////////////
Declare Function SetVoltage(fVoltage As Float) As Byte
Declare Function Getinlerr(fVoltage As Float) As Float
Declare Function Getfolat(wH As Word, wL As Word) As Float
'Declare Function GetDecimal(wH As Word, wL As Word) As Float

Declare Function ReadADConvert(NextChannel As Byte) As Long
Declare Function FixADCResult() As Byte
Declare Function WriteResultREG(bSetp As Byte, bArea As Byte) As Byte 
Declare Function MoveResultREG(bSetp As Byte, bArea As Byte) As Byte 
Declare Function ReadADCResult(bChannel As Byte) As Float
Declare Sub StatusDisplay()
Declare Function UpdateTempresultInfo() As Byte
Declare Sub Trigcompleted()
Declare Function ADCheck(bNextChannel As Byte) As Integer

Declare Function Selftest() As Byte
Declare Function Debug(iTestcode As Byte) As Byte
Declare Function EEPROMCheck() As Byte
Declare Function EEPROMInit() As Byte

Declare Function Uartlk(tkType As Byte) As Byte
Declare Function UartProcess() As Byte
'///////////////////////////////////////////////////////////////////////////////////////////////////
									' UART Interrupt
'///////////////////////////////////////////////////////////////////////////////////////////////////
Declare Interrupt Urxc()
Declare Interrupt Int0()

bPowerUp = 0

rstt:  'Full Reset flag

'************** Enable the Keyboard **************
'Int0 Rising 'Falling '
Enable Interrupts
'Enable Int0
'************** Enable the Keyboard **************						
'Enable Interrupts
Enable Urxc

'///////////////////////////////////////////////////////////////////////////////////////////////////
							' Config the MCU IO Register
'///////////////////////////////////////////////////////////////////////////////////////////////////
DDRA = &b11111111		'Display Screen Data Bus
							'Parallel 8bit Data bus
DDRC = &b11111111		'Display Screen Control Bus
							'PC0: (Saved)
							'PC1: (Saved)
							'PC2: Screen Strobe
							'PC3: Screen Write or Read
							'PC4: Screen Data or Instructions
							'PC5: Screen Area Enable LO Bit
							'PC6: Screen Area Enable HI Bit
							'PC7: Screen Reset
DDRB = &b10110111		'Analog Board Connect
							'REG STB <--- PB0 
							'REG DAT <--- PB1
							'REG CLK <--- PB2
							'ADC CLK <--- PB3
							'ADC DAT ---> PB4
							'KEY STB <--- PB5
							'KEY DAT ---> PB6
							'KEY CLK <--- PB7
DDRD = &b11111011		'INT, UART and PWM Control
							'PD0: UART RX
							'PD1: UART TX
							'PD2: INT0 TRIG(Key)
							'PD3: INT1 TRIG(Saved)
							'PD4: PWM OC1B(Saved)
							'PD5: PWM OC1A(Saved)
							'PD6: 1Wire BUS(DS18b20)
							'PD7: PWM OC2(Saved)		
PORTA = &b00000000						
PORTB = &b01000000
PORTC = &b00000000
PORTD = &b00000000
'///////////////////////////////////////////////////////////////////////////////////////////////////
									' Program Initialization
'///////////////////////////////////////////////////////////////////////////////////////////////////						
'					======== If Reset ========
' Analog Board Initialization, Open all Analog Switch
bSregister = ADCPWDown
WriteSReg(bSregister)

'Initialization Reference Value
fMasterReference = cfMasterReference	'LM399 Voltage Value	
fDACReference = cfDACReference		'DAC Voltage Reference Value
fDACGain = cfDACGain					'DAC Output buff Gain
fMResistance = cfMResistance			'DAC Voltgae Compound Resistance, the Master
fSResistance = cfSResistance
fQuadratic = cQuadratic				'No-line Error Adjuest Quadratic Coefficient	ϵ
fLinear = cLinear						'No-line Error Adjuest Linear Coefficient		һϵ
fConstant = cConstant					'No-line Error Adjuest Offset Coefficient		
'fDacal = 1							'DAC Fullscale Error Adjuest Vale	
bINLCorrect = 1

' DAC Initialization to 0V Output
SetVoltage(0)
'					======== If Reset Up ========

'					======== If Power Up ========
InitKS()				' ʼʾ
ClsKS(0)				' 
' LCD Test and Init Display Charat
			Charat = "Voltage Generator" : DrawChrLarge(6,1)
			Charat = "Version 0.9" : DrawChr(32,3)
			Charat = "Build 300E1" : DrawChr(44,4)
			Charat = "By Lilith Washu" : DrawChr(38,6)
			WaitMs 200
			If bPowerUp = 0 Then
				Charat = "Initialization Power..." : DrawChr(1,7)
				Wait 2		'Wait for Analog board Power Up and LM399 heating...
			End If
			bPowerUp = 1	

						
SetVoltage(0)			' DAC Initialization to 0V Output

IO_ADC_CLK = 0			'Initialization ADC(Set the LTC2400 CLK = 0 for Power Up)
bSregister = ADCPWDown
WriteSReg(bSregister)	'Initialization ADC(Set the LTC2400 to Extrnal Clock Mode)
WaitMs 200					
'					======== If Power Up ========

ClsKS(0)
Charat = "Initialization EEPROM" : DrawChr(1,0)

bSregister = ADCWalkUp + GndOffset
WriteSReg(bSregister)	'Walkup the ADC
WaitMs 200				'Wait for LTC2400 Converted

'///////////////////////////////////////////////////////////////////////////////////////////////////
									' EEPROM Initialization
'///////////////////////////////////////////////////////////////////////////////////////////////////
'Initialization Var and EEPROM
Charat = "Check EEPROM now..." : DrawChr(1,1)
WaitMs 200
iEEPROM = ReadEE(0)
If iEEPROM = 255 Then
	Charat = "CANCEL!" : DrawChr(79,1)
	Charat = "EEPROM EMPTY!" : DrawChr(1,6)
	Charat = "LOAD DEFAULT" : DrawChr(1,7)
Else
	iErrcode = EEPROMCheck()
	If iErrcode = 0 Then
		ClsKS(0)
		Charat = "Check EEPROM SUCCES" : DrawChr(1,1)
		Charat = "Initialization EEPROM" : DrawChr(1,0)
		iErrcode = EEPROMInit()
		Charat = Hex(iErrcode) : DrawChr(1,7)
	Else
		Charat = "FAILED!" : DrawChr(79,1)
		Charat = "EEPROM BREAK!" : DrawChr(1,6)
		Charat = "LOAD DEFAULT" : DrawChr(1,7)
	End If
End If
'***************** Show float Setting Value *****************
Format(2,6)
Charat = Str(fMasterReference) : DrawChr(13,2)
Charat = Str(fDACReference) : DrawChr(109,2)
Charat = Str(fDACGain) : DrawChr(13,3)
Format(7,1)
Charat = Str(fMResistance) : DrawChr(109,3)
Charat = Str(fSResistance) : DrawChr(13,4)
Format(5,3)
Charat = Str(fQuadratic) : DrawChr(109,4)
Charat = Str(fLinear) : DrawChr(13,5)
Charat = Str(fConstant) : DrawChr(109,5)
'***************** Show float Setting Value *****************
Wait 2
ClsKS(0)
Charat = "Initialization     OK" : DrawChr(1,0)

iKeypress = 0
iKeycode = 0
bRst = 0

'///////////////////////////////////////////////////////////////////////////////////////////////////
									' Self Test
'///////////////////////////////////////////////////////////////////////////////////////////////////
bRun = 0
iErrcode = Selftest()
If iErrcode > 1 Then
	Charat = "Failed" : DrawChr(91,1)
	Charat = "Code:" : DrawChr(1,7)
	Format(3,0) : Charat = Str(iErrcode) : DrawChr(31,7)
	'SetChannel(Synthesis)
	Wait 5
	Debug(iErrcode)
Else
	Charat = "OK" : DrawChr(115,1)
End If
Wait 1	


'///////////////////////////////////////////////////////////////////////////////////////////////////
									' Self Test End
'///////////////////////////////////////////////////////////////////////////////////////////////////



Wait 1	'Wait the LM399 Warmed
ClsKS(0)
' Screen Fixed Display Initialization
			Charat = "SET:"
			DrawChrLarge(1,0)
			Charat = "REB:"
			DrawChrLarge(1,2)
			Charat = "VDC"
			DrawChrLarge(105,0)
			DrawChrLarge(105,2)
' Right Sataus Lable Display
			'Charat = "MH:"
			'DrawChr(156,0)
			'Charat = "ML:"
			'DrawChr(156,1)
			'Charat = "SH:"
			'DrawChr(156,2)
			'Charat = "SL:"
			'DrawChr(156,3)
			Charat = "W:" : DrawChr(132,7)
			
			Charat = "ADJ:"
			DrawChr(162,7)
			'Charat = "M=" : DrawChr(126,6)
			'Charat = "S=" : DrawChr(126,7)
			Charat = "MS:" : DrawChr(126,0)
			Charat = "M" : DrawChr(126,1)
			Charat = "S" : DrawChr(126,2)
			Charat = "T" : DrawChr(126,3)
			Charat = "R" : DrawChr(126,4)
			Charat = "G" : DrawChr(126,5)
'Botton Sataus Label Display
			Charat = "IGNO" : DrawChr(9,4)
			Charat = "EXEC" : DrawChr(9,5)
			Charat = "TemP" : DrawChr(12,6)
			Charat = "Filt" : DrawChr(98,6)
			Charat = "ErroR" : DrawChr(52,5)
			Charat = "INL:" : DrawChr(132,6)
			Charat = "uV" : DrawChr(64,6)
			Charat = "RuN" : DrawChr(100,5)
			Charat = "StP" : DrawChr(100,4)
			
			Charat = "UNLOCK" : DrawChr(37,4)
' Cursors Draw
			'MemLoad(VarPtr(iCursors), &b00001000, &b00011100, &b00111110, &b01111111) : DrawCursors(1, 4, 4)				' Display a "<" Cursors
			'MemLoad(VarPtr(iCursors), &b01111111, &b00111110, &b00011100, &b00001000) : DrawCursors(1, 4, 4)				' Display a ">" Cursors
			'MemLoad(VarPtr(iCursors), &b00000100, &b00000110, &b00000111, &b00000110, &b00000100) : DrawCursors(1, 4, 5) 	' Display a "^" Cursors
If IsTempresultSense = 1 Then
			MemLoad(VarPtr(iCursors), &b00000110, &b00001001, &b00001001, &b000000110) : DrawCursors(31, 7, 4)				' Display a  Degree Cursors
			Charat = "C" : DrawChr(37,7)
			UpdateTempresultInfo()
End If
'///////////////////////////////////////////////////////////////////////////////////////////////////
									' Program Initialization End
'///////////////////////////////////////////////////////////////////////////////////////////////////
' Start the Temperature Sense(DS18b20) Convert
'1Wreset
'1Wwrite &hcc; &h44
'///////////////////////////////////////////////////////////////////////////////////////////////////
									' Running  Register Initialization
'///////////////////////////////////////////////////////////////////////////////////////////////////
' Init the DAC Output Default
fSetting = 10000000
fVoltage = fSetting
' Program Reset Point:
stt:	
bRst = 0							
'fVoltage = fVoltage / fDacal
SetVoltage(fVoltage)
' All Setting Register Value Initialization to Default
fReference = 0
fSynthesis = 0
fCalsacles = fMasterReference
iSmlen = 32				' the Sommth Length, 1 Trig Cycle(Adjuest Cycle) = 3 x Sommth Length
bDigitaLoop = 1			' Digital Loop = Close Loop(0=Open Loop)
itm = 0
iSmsetp = 0				' Current Program Running Setp
bRun = 1				' Flag the Program Run or Setp, 1 = Run
bRefsource = 0			' Flag the Reference Source, 0 = INT, 1 = EXT
bNextchannel = 0		' Flag the Analog Switch Channel
bAdjuest = 0			' Flag is/isnot Adjuest Output Voltage
bUartlk = 0				' Flag the UART Port Talk,bit 8 = All Talk; bit 1 = talk when Trigcompleted.
bUartINT = 0
bUartset = 2
' Display and Update the Output Voltage Setting Value
Format(2,0)
Charat = Str(iSmlen) : DrawChr(104,7)
'Charat = Str(iSmlen * 3 + 1) : DrawChr(179,7)
Charat = "pt"  :  DrawChr(116,7)
Charat = "/" :  DrawChr(98,7)

Format(2,6)
fTrn = fSetting / 1000000
Charat = Str(fTrn)
DrawChrLarge(28,0)

iLock = 0
iUnlockCount = 0


'\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\

										'Program Main Loop

'///////////////////////////////////////////////////////////////////////////////////////////////////
Do
	If bRun = 0 Then
		Charat = " ---------" : DrawChrLarge(28,2)
		MemLoad(VarPtr(iCursors), &h00, &h00, &h00, &h00) : DrawCursors(120, 5, 4)
		MemLoad(VarPtr(iCursors), &h08, &h1C, &h3E, &h7F) : DrawCursors(120, 4, 4)
		iSmsetp = 0
		WaitMs 100
		GoTo Runout
	Else
		MemLoad(VarPtr(iCursors), &h00, &h00, &h00, &h00) : DrawCursors(120, 4, 4)
		MemLoad(VarPtr(iCursors), &h08, &h1C, &h3E, &h7F) : DrawCursors(120, 5, 4)	
	End If
	
	bNextchannel = bNextchannel + 1
	If bNextchannel > 3 Then bNextchannel = 1
	iBusystp = 0
	Do
		iBusystp = iBusystp + 1
		WaitMs 1
	Loop While IO_ADC_DAT = 1 
	Select Case bNextChannel
			Case 1 : CurrentChannel = SetChannel(Reference)
			Case 2 : CurrentChannel = SetChannel(GndOffset)
			Case 3 : CurrentChannel = SetChannel(Synthesis)
	End Select
	
	Charat = Hex(iBusystp) : DrawChr(144,7)

	If bRst > 0 Then
		If bRst = 2 Then GoTo rstt
		If bRst = 1 Then GoTo stt
	End If
	'inowA = ReadADC()
	'inowB = ReadADC()
	'inowC = ReadADC()
	'inowD = ReadADC()
	'inowA = ShiftIn
	'inowB = ShiftIn
	'inowC = ShiftIn
	'inowD = ShiftIn	
	
	'Print Hex(inowA); " "; Hex(inowB); " "; Hex(inowC); " "; Hex(inowD)
	
	'bADCResult(3) = inowA
	'bADCResult(2) = inowB
	'bADCResult(1) = inowC
	'bADCResult(0) = inowD

	
	'bADCResult(3) = ReadADC() 'ShiftIn
	'bADCResult(2) = ReadADC() 'ShiftIn
	'bADCResult(1) = ReadADC() 'ShiftIn
	'bADCResult(0) = ReadADC() 'ShiftIn
	
	Disable Interrupts
	'Disable Urxc
	
	bADCResult(3) = ShiftIn
	bADCResult(2) = ShiftIn
	bADCResult(1) = ShiftIn
	bADCResult(0) = ShiftIn	 
	FixADCResult()
	
	Enable Interrupts
	'Enable Urxc
	
	'inowA = bADCResult(3)
	'inowB = bADCResult(2)
	'inowC = bADCResult(1)
	'inowD = bADCResult(0)
	'fTrn = 5 * 2.5 * (16777216 * inowa + 65536 * inowb + 256 * inowc + inowd - 33554432) / 16777216
	'Select Case bNextChannel
		'Case 1 : nfGndOffset = fTrn
		'Case 2 : nfReference = fTrn
		'Case 3 : nfSynthesis = fTrn
	'End Select
	'Format(2,6)
	'If bNextChannel = 1 Then
		'Charat = Str(nfSynthesis) : DrawChr(37,4)
		'Charat = Str(nfReference) : DrawChr(37,5)
		'Charat = Str(nfGndOffset) : DrawChr(37,6)
		'Print nfSynthesis; "/"; nfReference; "/"; nfGndOffset
	'End If	
	
	For i = 1 To iSmlen
		MoveResultREG(i, bNextchannel)
	Next i
	WriteResultREG(iSmlen, bNextchannel)
	
	iSmsetp = iSmsetp + 1
	Format(2,0)
	Charat = Str(iSmsetp/3)
	DrawChr(86,7)
	
	fSynthesis = ReadADCResult(1) 'syn
	fReference = ReadADCResult(2) 'ref
	fGndOffset = ReadADCResult(3) 'gnd
	
	Format(2,6)
	Charat = Str(fSynthesis) : DrawChr(132,3)
	Charat = Str(fReference) : DrawChr(132,4)
	Charat = Str(fGndOffset) : DrawChr(132,5)
	
	fCalfSynth = (fSynthesis - fGndOffset) / ((fReference - fGndOffset) / fCalsacles)
	fCalfSynth = fCalfSynth + Getinlerr(fCalfSynth)/ 1000000
	
	fTrn = Getinlerr(fCalfSynth)
	Format(3, 1) : Charat = Str(fTrn) : DrawChr(156, 6)
	
	fError = fSetting - fCalfSynth * 1000000
	iError = fError
	wError = iError * iError	
	
	Format(2,6)
	Charat = Str(fCalfSynth)
	DrawChrLarge(28,2)
		
	Format(4,0)
	Charat = "     " : DrawChr(52,7)
	Charat = Str(iError) : DrawChr(52,7)
	'Charat = Str(wError) : DrawChr(1,5)
	
	iErrlimit = 0
	If wError > 99 Then iErrlimit = 1
	bAdjuest = bDigitaLoop And iErrlimit
	
	Format(1,0)
	Charat = Str(bAdjuest) : DrawChr(186,7)
	
	If iSmsetp = iSmlen * 3 + 1 Then
		iSmsetp = 0 
		Trigcompleted()
		If iError > 1000 Then 
			iLock = 0
			Charat = "UNLOCK"
		End If	
		If iError + 1001 < 1 Then
			iLock = 0
			Charat = "UNLODK"
		End If
		If wError < 10000 Then Charat = "TRACK "
		If wError < 49 Then
			iLock = 1
			Charat = "LOCKED"
		End If	
		DrawChr(37,4)
		If iLockPrv <> iLock Then
			If iLockPrv = 1 Then iUnlockCount = iUnlockCount + 1
			iLockPrv = iLock
			Charat = Hex(iUnlockCount) : DrawChr(75,4)
		End If
	End If
		
	Runout: 

	If bUartINT = 1 Then
		bUartINT = 0
		UartProcess()				
	End If	
	
	If bUartset = 1 Then
		bUartset = 0 
		iSmsetp = 0
		fVoltage = fSetting
		'fVoltage = fVoltage / fDacal
		SetVoltage(fVoltage)
		fTrn = fSetting / 1000000
		Format(2,6)
		Charat = Str(fTrn)
		DrawChrLarge(28,0)
	End If
	
	If bUartset = 2 Then
		bUartset = 0
		StatusDisplay()
	End If
	
	If iKeypress = 1 Then
		iKeypress = 0
		WaitMs 1
		iKeycode = ReadKey() + ReadKey() * 256
	End If
	'Charat = Hex(iKeycode) : DrawChr(1,6)
Loop
End

'\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\

										'Operation Sub and Function

'///////////////////////////////////////////////////////////////////////////////////////////////////
Function Uartlk(tkType As Byte) As Byte
Select Case tkType
		Case 1 : Format(2,6) : Print fSynthesis
		Case 2 : Format(2,6) : Print fReference
		Case 4 : Format(2,6) : Print fGndOffset
End Select
Return 0
End Function

Function UartProcess() As Byte
Local wEEPROMh As Word
Local wEEPROMl As Word
Local rEEPROMh As Word
Local rEEPROMl As Word
Local cEEPROMh As Word
Local cEEPROMl As Word
Local bEEPAddr As Byte
Local uVseth As Word
Local uVsetl As Word
Local bSett As Byte

tCmd = Mid(tTxt, 1, 3)

If tCmd = "STV" Then
   tm = Mid(tTxt,4,4)
   uVseth = Val(tm)
   tm = Mid(tTxt,8,4)
   uVsetl = Val(tm)
   fVtrn = uVseth
   fVtrn = fVtrn * 10000
   fVtrn = fVtrn + uVsetl
   tm = Mid(tTxt,12,1)
   bSett = Val(tm)
   If bSett = 0 Then
      fSetting = fVtrn
      bUartset = 1  
   End If
   If bSett = 1 Then
      fCalsacles = fVtrn
      bUartset = 1
   End If
End If

If tCmd = "STS" Then
   tm = Mid(tTxt,4,1)
   If tm <> "x" Then bDigitaLoop = Val(tm)
   tm = Mid(tTxt,12,1)
   If tm <> "x" Then bRun = Val(tm)
   tm = Mid(tTxt,11,1)
   If tm <> "x" Then bRefsource = Val(tm)
   bUartset = 2
End If

If tCmd = "STE" Then
	wEEPROMh = 0
	rEEPROMh = 0
	tm = Mid(tTxt,4,3)
	bEEPAddr = Val(tm)
	tm = Mid(tTxt,7,5)
	wEEPROMh = Val(tm)
	WriteEE (bEEPAddr, wEEPROMh)
	WriteEE (bEEPAddr + 100 ,wEEPROMh)
	rEEPROMh = ReadEE(bEEPAddr)
	Format (5,0)
	Print "ReChk Addr "; Hex(bEEPAddr); " Value ";  rEEPROMh
End If

If tCmd = "RTE" Then
	tm = Mid(tTxt,4,3)
	bEEPAddr = Val(tm)
	rEEPROMh = ReadEE(bEEPAddr)
	rEEPROMl = ReadEE(bEEPAddr + 2)
	cEEPROMh = ReadEE(bEEPAddr + 100)
	cEEPROMl = ReadEE(bEEPAddr + 102)
	Format (5,0)
	Print "EEPADDr "; Hex(bEEPAddr); " ,MSB "; rEEPROMh; " ,LSB "; rEEPROMl; " ;CMSB "; cEEPROMh; " ,CLSB "; cEEPROMl
End If

If tCmd = "RST" Then
   Print "RST"
   tm = Mid(tTxt,4,1)
   bRst = Val(tm)
End If

Return 0
End Function

Sub StatusDisplay()
If bDigitaLoop = 1 Then
	MemLoad(VarPtr(iCursors), &h00, &h00, &h00, &h00) : DrawCursors(1, 4, 4)
	MemLoad(VarPtr(iCursors), &h7F, &h3E, &h1C, &h08) : DrawCursors(1, 5, 4)
Else
	MemLoad(VarPtr(iCursors), &h00, &h00, &h00, &h00) : DrawCursors(1, 5, 4)
	MemLoad(VarPtr(iCursors), &h7F, &h3E, &h1C, &h08) : DrawCursors(1, 4, 4)
End If

End Sub

Function UpdateTempresultInfo() As Byte
	1Wreset
	1Wwrite &hcc; &hbe
	1Wread dTempdatum ,2
	1Wreset
	1Wwrite &hcc; &h44
	dTempresult = dTempdatum(0)
	fTemperature = dTempresult
	fTemperature = fTemperature / 16
	Format(2,1) : Charat = Str(fTemperature) : DrawChr(1,7)
End Function

Sub Trigcompleted()
	If bAdjuest = 1 Then
		fVoltage = fVoltage + fError
		SetVoltage(fVoltage)
	End If
	If IsTempresultSense = 1 Then UpdateTempresultInfo()
	If bUartlk > 0 Then
		Format(3,2)
		Charat = Str(fTemperature)
		Format(5,1)
		Print fError; " "; Charat
	End If
End Sub

'///////////////////////////////////////////////////////////////////////////////////////////////////
							' Return the 24bit Result from 32bit Data
'///////////////////////////////////////////////////////////////////////////////////////////////////
Function FixADCResult() As Byte
iDa = bADCResult(3)
iDb = bADCResult(2)
iDc = bADCResult(1)
iDd = bADCResult(0) 
' Casting out the lower 4bit Data and Return the low 8bit Result
iDd = iDd And &b11110000
iDd = Swap(iDd)
iTrd = iDc And &b00001111
iTrd = Swap(iTrd)
iTd = iDd + iTrd
' Move and Return the middle 8 bit Result
iTrd = iDc And &b11110000
iTc = Swap(iTrd)
iTrd = iDb And &b00001111
iTrd = Swap(iTrd)
iTc = iTrd + iTc
' Move and Return the hihg 8 bit Result
iTrd = iDb And &b11110000
iTb = Swap(iTrd)
iTrd = iDa And &b00001111
iTrd = Swap(iTrd)
iTb = iTrd + iTb  
' Return the Overload and Sign Bit
iTrd = iDa And &b00110000
iTa = Swap(iTrd)
' Copy Result to Public Array
bADCResult(3) = iTa
bADCResult(2) = iTb
bADCResult(1) = iTc
bADCResult(0) = iTd
Return 0
End Function

'///////////////////////////////////////////////////////////////////////////////////////////////////
							' Write a ADC Result to FIFO Movewindow Array
'///////////////////////////////////////////////////////////////////////////////////////////////////
Function WriteResultREG(bSetp As Byte, bArea As Byte) As Byte 
iTrd = (bArea - 1) * iSmlen + bSetp 
bREGa(iTrd) = bADCResult(3)
bREGb(iTrd) = bADCResult(2)
bREGc(iTrd) = bADCResult(1)
bREGd(iTrd) = bADCResult(0)
End Function

'///////////////////////////////////////////////////////////////////////////////////////////////////
							' Move the FIFO Array
'///////////////////////////////////////////////////////////////////////////////////////////////////
Function MoveResultREG(bSetp As Byte, bArea As Byte) As Byte 
iTrd = (bArea - 1) * iSmlen + bSetp 
bREGa(iTrd) = bREGa(iTrd + 1)
bREGb(iTrd) = bREGb(iTrd + 1)
bREGc(iTrd) = bREGc(iTrd + 1)
bREGd(iTrd) = bREGd(iTrd + 1)
End Function

'///////////////////////////////////////////////////////////////////////////////////////////////////
							' Return a Float Format Smohth ADC Result 
'///////////////////////////////////////////////////////////////////////////////////////////////////
Function ReadADCResult(bChannel As Byte) As Float
fTrn = 0
fOut = 0
For i = 1 To iSmlen
	iTrd = (bChannel - 1) * iSmlen + i
	iTa = bREGa(iTrd)
	iTb = bREGb(iTrd)
	iTc = bREGc(iTrd)
	iTd = bREGd(iTrd)
	fTrn = 5 * 2.5 * (16777216 * iTa + 65536 * iTb + 256 * iTc + iTd - 33554432) / 16777216
	fOut = fOut + fTrn
Next i
fOut = fOut / iSmlen
Return fOut
End Function



Function DrawCursors(x As Byte, Page As Byte, Length As Byte) As Byte
For i = 0 To Length - 1
	DrawPage(x + i, Page, iCursors(i))
Next i
End Function


Function ADCheck(bNextChannel As Byte) As Integer
Local iChkresutl As Integer
Local iChk1 As Byte
Local iChk2 As Byte
Local iChk3 As Byte
Local iChk4 As Byte
Do
Loop While IO_ADC_DAT = 1
SetChannel(bNextChannel) : WaitMs 10
'iChk4 = ShiftIn : iChk3 = ShiftIn : iChk2 = ShiftIn : iChk1 = ShiftIn
iChk4 = ReadADC()  : iChk3 = ReadADC()  : iChk2 = ReadADC()  : iChk1 = ReadADC() 

bADCResult(3) = iChk4 : bADCResult(2) = iChk3 : bADCResult(1) = iChk2 : bADCResult(0) = iChk1 
iChkresutl = iChk4 * 4
iChkresutl = iChkresutl * 256 + iChk3 * 4 - 32768
Return iChkresutl / 4
End Function



'///////////////////////////////////////////////////////////////////////////////////////////////////
							' Read Analog Board ADC Result Shift-Register
'///////////////////////////////////////////////////////////////////////////////////////////////////
Function ReadADC() As Byte
Local myByte As Byte
Local i As Byte
myByte = 0

' Read 8bit = 1 Byte Result form ADC Shift-Out Register(2Wire Serial Bus ADC)
For i = 0 To 7
    IO_ADC_CLK = 1 
    'PORTC.0 = 1
    'MyWait()
    'MyWait()
    'PORTC.0 = 0
    Rotate(Left,1,myByte)
    WaitUs 1    
    myByte = myByte + IO_ADC_DAT
    'WaitUs 1 
    IO_ADC_CLK = 0
    WaitUs 1   
    'MyWait()
    'MyWait()
    'MyWait() 
    'MyWait()     
Next i
' Return 1 Byte Result to Function
Return myByte
End Function

Function MyWait() As Byte
Return 0
End Function

'///////////////////////////////////////////////////////////////////////////////////////////////////
							' Read MCU Block Keyboard Status Shift-Register
'///////////////////////////////////////////////////////////////////////////////////////////////////
Function ReadKey() As Byte
Local myByte As Byte
Local i As Byte
myByte = 0
' Read 8bit = 1 Byte Result form Keyboard Shift-Out Register(74HC165)
For i = 0 To 7 
    Rotate(Left,1,myByte)
    myByte = myByte + IO_KEY_DAT
    IO_KEY_CLK = 1 
    WaitUs 1
    IO_KEY_CLK = 0
    WaitUs 1      
Next i
' Return 1 Byte Result to Function
myByte = Not myByte
Return myByte
End Function


'\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\

										'Shiftreg IO

'///////////////////////////////////////////////////////////////////////////////////////////////////


'///////////////////////////////////////////////////////////////////////////////////////////////////
							' Wrtie the Analog board Control Shift-Register
'///////////////////////////////////////////////////////////////////////////////////////////////////
Function WriteSReg(bDat As Byte) As Byte
Local i As Byte
Local bWritedat As Byte
Local bWritebit As Byte
bWritedat = bDat
IO_REG_DAT = 0
IO_REG_CLK = 0
IO_REG_STB = 0
WaitUs 1
For i = 1 To 8
    bWritebit = bWritedat And &b10000000
    If bWritebit = 128 Then
       IO_REG_DAT = 1
    Else
       IO_REG_DAT = 0
    End If 
    WaitUs 1
    IO_REG_CLK = 1 : WaitUs 1 : IO_REG_CLK = 0
    bWritedat = Shift(Left, 1, bWritedat)  
Next i
WaitUs 1
IO_REG_STB = 1 : WaitMs 1 : IO_REG_STB = 0
IO_REG_DAT = 0
IO_REG_CLK = 0

Return 0
End Function
'///////////////////////////////////////////////////////////////////////////////////////////////////
							' Wrtie the DAC Shift-Register
'///////////////////////////////////////////////////////////////////////////////////////////////////
Function WriteSBUS(bDat As Byte) As Byte
Local i As Byte
Local bWritedat As Byte
Local bWritebit As Byte
bWritedat = bDat
IO_REG_DAT = 0
IO_REG_CLK = 0
WaitUs 1
For i = 1 To 8
    bWritebit = bWritedat And &b10000000
    If bWritebit = 128 Then
       IO_REG_DAT = 1
    Else
       IO_REG_DAT = 0
    End If 
    WaitUs 1
    IO_REG_CLK = 1 : WaitUs 1 : IO_REG_CLK = 0
    bWritedat = Shift(Left, 1, bWritedat)  
Next i
WaitUs 1

IO_REG_DAT = 0
IO_REG_CLK = 0

Return 0
End Function



'\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\

									'Mathematical Function

'///////////////////////////////////////////////////////////////////////////////////////////////////


'///////////////////////////////////////////////////////////////////////////////////////////////////
							' ADC No-line Error Adjuest
'///////////////////////////////////////////////////////////////////////////////////////////////////
Function Getinlerr(fVoltage As Float) As Float			
fVtrn = fVoltage 
fVset = fVtrn * fVtrn * fQuadratic + fVtrn * fLinear + fConstant
'fVset = fVtrn * fVtrn * fVtrn * Cubic + fVtrn * fVtrn * Quadratic + fVtrn * Linear + Constant
End Function









'\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\

									'INT Process

'///////////////////////////////////////////////////////////////////////////////////////////////////

Interrupt Urxc(),Save All
bUartINT = 1
InputBin tTxt
Enable Interrupts
End Interrupt

Interrupt Int0(), Save 0
iKeypress = 1
Enable Interrupts
End Interrupt

$Include "inc\AD569drv.bas"
'$Include "inc\k12864drv.bas"
$Include "inc\ks0108drv.bas"
$Include "inc\selftest.bas"
$Include "inc\initeep.bas"
$Include "inc\font1.bas"
$Include "inc\font2.bas"